COMMENT
Random number source that returns values sampled
from a uniform distribution over the range [lo,hi]).
Developed to be used as drive for a noise current density mechanism.

Borrows from NetStim's code so it can be linked with an external instance 
of the Random class in order to generate output that is independent of 
other instances of ARandUni
.
ENDCOMMENT

NEURON {
    : make name early in alphabet
    : so this mechanism will be evaluated before mechanisms that depend on it
    POINT_PROCESS ARandUni : other classes could be InBin, InGau or InNor, InExp
    RANGE lo, hi, x
    THREADSAFE : true only if every instance has its own distinct Random
    POINTER donotuse
}

UNITS {
    (nA) = (nanoamp)
}

PARAMETER {
    lo = 0
    hi = 1
}

ASSIGNED {
    x
    donotuse
}

: is this even useful?  yes, if each instance is not paired with its own generator
PROCEDURE seed(x) {
    set_seed(x)
}

BEFORE BREAKPOINT {
    x = (hi-lo)*urand() + lo

: printf("ARandUni BB time %g  x %g\n", t, x)
}

VERBATIM
double nrn_random_pick(void* r);
void* nrn_random_arg(int argpos);
ENDVERBATIM

: FUNCTION erand() {
FUNCTION urand() {
VERBATIM
    if (_p_donotuse) {
        /*
         : Supports separate independent but reproducible streams for
         : each instance. However, the corresponding hoc Random
:         : distribution MUST be set to Random.negexp(1)
         : distribution MUST be set to Random.uniform(0,1)
         */
//            _lerand = nrn_random_pick(_p_donotuse);
            _lurand = nrn_random_pick(_p_donotuse);
    }else{
        /* only can be used in main thread */
        if (_nt != nrn_threads) {
hoc_execerror("multithread random in InUnif"," only via hoc Random");
        }
ENDVERBATIM
        : the old standby. Cannot use if reproducible parallel sim
        : independent of nhost or which host this instance is on
        : is desired, since each instance on this cpu draws from
        : the same stream
:        erand = exprand(1)
        urand = scop_random()
VERBATIM
    }
ENDVERBATIM
}

PROCEDURE noiseFromRandom() {
VERBATIM
 {
    void** pv = (void**)(&_p_donotuse);
    if (ifarg(1)) {
        *pv = nrn_random_arg(1);
    }else{
        *pv = (void*)0;
    }
 }
ENDVERBATIM
}

